/* sample8.c */
#include <GL/glut.h>
#include <math.h>
#include <stdlib.h>


float param = 0.0;
int flag = 0;

float diffuse[] = {0.8, 0.8, 0.8, 1.0};  /* gUː̔ˋx*/
float specular[] = {1.0, 1.0, 1.0, 1.0}; /* ʔː̔ˋx */
float ambient[] = {0.2, 0.2, 0.2, 1.0};  /* ̔ˋx*/
float shininess = 128.0;

void display(void)
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); /* zobt@ */

  glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse);
  glMaterialfv(GL_FRONT, GL_SPECULAR, specular);
  glMaterialfv(GL_FRONT, GL_AMBIENT, ambient);
  glMaterialf(GL_FRONT, GL_SHININESS, shininess);
  glEnable(GL_LIGHTING);

  glPushMatrix();
  glTranslatef(0.0, 1.0, 0.0);
  glutSolidCube(2.0);

  glPushMatrix();
  glTranslatef(-0.5, 0.5, 1.0);
  glutSolidSphere(0.2, 10, 10);
  glPopMatrix();

  glPushMatrix();
  glTranslatef(0.5, 0.5, 1.0);
  glutSolidSphere(0.2, 10, 10);
  glPopMatrix();

  glPushMatrix();
  glTranslatef(0.0, 0.0, 1.1);
  glutSolidCube(0.2);
  glPopMatrix(); 

  glPopMatrix();

  glDisable(GL_LIGHTING);
  glutSwapBuffers();
}

void idle(void)
{
  if(flag == 1){
    param = fmod(param+1.0, 360.0);  /* ]p0`360x܂ŁC1x */
  }
  glutPostRedisplay();
}

void mouse(int button, int state, int x, int y)
{
  if(state == GLUT_DOWN){     /* }EXNbN */
    switch(button){
    case GLUT_LEFT_BUTTON:    /*NbNꂽ̂{^ */
      flag = 1;               /* {^NbNꂽƂɍs */
      break;
    case GLUT_RIGHT_BUTTON:   /*NbNꂽ̂E{^ */
      flag = 0;               /* E{^NbNꂽƂɍs */
      break;
    }
  }
}

void keyboard(unsigned char key, int x, int y)
{
  static float col[4][4] =
    {{1.0, 0.0, 0.0, 1.0},
    {0.0, 1.0, 0.0, 1.0},
    {0.0, 0.0, 1.0, 1.0},
    {1.0, 1.0, 1.0, 1.0}};
  static int index = 0;
  static int smooth = 0;
  switch (key) {
  case 'q':                   /* q͂ꂽCvOI */
    exit(0);
  case 'r':
    param += 30.;
    break;
  case 'c':
    index++;
    index %= 4;
    glMaterialfv(GL_FRONT, GL_DIFFUSE, col[index] );
    break;
  case 's':
    if( smooth )
      glShadeModel(GL_SMOOTH);
    else
      glShadeModel(GL_FLAT);
    smooth = !smooth;
    break;
  default:
    break;
  }
}

void init(char *winname)
{
  glutInitWindowPosition(0, 0);
  glutInitWindowSize(500, 500);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH); /* zobt@p̐錾 */
  glutCreateWindow(winname);

  glClearColor(0.2, 0.4, 0.4, 1.0);

  glMatrixMode(GL_PROJECTION); /* e@ɊւWϊJn */
  glLoadIdentity();
  gluPerspective( 30.0, 1.0, 1.0, 10.0 );
  glMatrixMode(GL_MODELVIEW); /* _̈ړ⃂f̈ړȂǓe@
                                 ȊO̍WϊJn */
  gluLookAt( 3.0, 4.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 );

  glShadeModel(GL_FLAT);     /* VF[fBO̎ނtbgVF[fBOɐݒ */
  glEnable(GL_LIGHT0);       /* LIGHT0̌Lɂ */

  glEnable(GL_DEPTH_TEST);   /* Bʏ̊Jn錾 */
}

int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  init(argv[0]);
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);
  glutMouseFunc(mouse);  /* }EX͂̃R[obN֐mouse̎w */
  glutIdleFunc(idle);
  glutMainLoop();
  return 0;
}
